# This file was auto-generated by Fern from our API Definition.

# isort: skip_file

from .types import (
    Ascending,
    Count,
    ErrorName,
    ErrorResponse,
    Labels,
    Limit,
    OrganizationId,
    PageToken,
    ValidationErrorResponse,
)
from .errors import IsTakenError, NotFoundError, ValidationError
from . import attachments, contexts, drafts, inboxes, messages, threads, webhooks
from .attachments import (
    Attachment,
    AttachmentContent,
    AttachmentContentType,
    AttachmentFilename,
    AttachmentId,
    AttachmentInline,
    AttachmentSize,
    SendAttachment,
)
from .client import AgentMail, AsyncAgentMail
from .contexts import (
    Context,
    ContextData,
    ContextId,
    ContextIsEvent,
    ContextMetadata,
    ContextType,
    CreateContextRequest,
    ListContextsResponse,
)
from .drafts import (
    CreateDraftRequest,
    Draft,
    DraftAttachments,
    DraftBcc,
    DraftCc,
    DraftHtml,
    DraftId,
    DraftItem,
    DraftLabels,
    DraftPreview,
    DraftSubject,
    DraftText,
    DraftTo,
    DraftUpdatedAt,
    ListDraftsResponse,
)
from .environment import AgentMailEnvironment
from .messages import (
    Addresses,
    ListMessagesResponse,
    Message,
    MessageAttachments,
    MessageBcc,
    MessageCc,
    MessageFrom,
    MessageHtml,
    MessageId,
    MessageItem,
    MessageLabels,
    MessagePreview,
    MessageRejectedError,
    MessageSubject,
    MessageText,
    MessageTimestamp,
    MessageTo,
    ReplyToMessageRequest,
    SendMessageAttachments,
    SendMessageBcc,
    SendMessageCc,
    SendMessageReplyTo,
    SendMessageRequest,
    SendMessageResponse,
    SendMessageTo,
    UpdateMessageRequest,
)
from .threads import (
    ListThreadsResponse,
    Thread,
    ThreadAttachments,
    ThreadId,
    ThreadItem,
    ThreadLabels,
    ThreadMessageCount,
    ThreadPreview,
    ThreadRecipients,
    ThreadSenders,
    ThreadSubject,
    ThreadTimestamp,
)
from .version import __version__
from .webhooks import (
    CreateWebhookRequest,
    EventId,
    EventType,
    EventTypes,
    InboxIds,
    ListWebhooksResponse,
    MessageReceivedPayload,
    SvixId,
    SvixSignature,
    SvixTimestamp,
    Url,
    Webhook,
    WebhookId,
)

__all__ = [
    "Addresses",
    "AgentMail",
    "AgentMailEnvironment",
    "Ascending",
    "AsyncAgentMail",
    "Attachment",
    "AttachmentContent",
    "AttachmentContentType",
    "AttachmentFilename",
    "AttachmentId",
    "AttachmentInline",
    "AttachmentSize",
    "Context",
    "ContextData",
    "ContextId",
    "ContextIsEvent",
    "ContextMetadata",
    "ContextType",
    "Count",
    "CreateContextRequest",
    "CreateDraftRequest",
    "CreateWebhookRequest",
    "Draft",
    "DraftAttachments",
    "DraftBcc",
    "DraftCc",
    "DraftHtml",
    "DraftId",
    "DraftItem",
    "DraftLabels",
    "DraftPreview",
    "DraftSubject",
    "DraftText",
    "DraftTo",
    "DraftUpdatedAt",
    "ErrorName",
    "ErrorResponse",
    "EventId",
    "EventType",
    "EventTypes",
    "InboxIds",
    "IsTakenError",
    "Labels",
    "Limit",
    "ListContextsResponse",
    "ListDraftsResponse",
    "ListMessagesResponse",
    "ListThreadsResponse",
    "ListWebhooksResponse",
    "Message",
    "MessageAttachments",
    "MessageBcc",
    "MessageCc",
    "MessageFrom",
    "MessageHtml",
    "MessageId",
    "MessageItem",
    "MessageLabels",
    "MessagePreview",
    "MessageReceivedPayload",
    "MessageRejectedError",
    "MessageSubject",
    "MessageText",
    "MessageTimestamp",
    "MessageTo",
    "NotFoundError",
    "OrganizationId",
    "PageToken",
    "ReplyToMessageRequest",
    "SendAttachment",
    "SendMessageAttachments",
    "SendMessageBcc",
    "SendMessageCc",
    "SendMessageReplyTo",
    "SendMessageRequest",
    "SendMessageResponse",
    "SendMessageTo",
    "SvixId",
    "SvixSignature",
    "SvixTimestamp",
    "Thread",
    "ThreadAttachments",
    "ThreadId",
    "ThreadItem",
    "ThreadLabels",
    "ThreadMessageCount",
    "ThreadPreview",
    "ThreadRecipients",
    "ThreadSenders",
    "ThreadSubject",
    "ThreadTimestamp",
    "UpdateMessageRequest",
    "Url",
    "ValidationError",
    "ValidationErrorResponse",
    "Webhook",
    "WebhookId",
    "__version__",
    "attachments",
    "contexts",
    "drafts",
    "inboxes",
    "messages",
    "threads",
    "webhooks",
]
