# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic
from ...core.pydantic_utilities import IS_PYDANTIC_V2
from ...core.unchecked_base_model import UncheckedBaseModel
from .context_data import ContextData
from .context_id import ContextId
from .context_is_event import ContextIsEvent
from .context_metadata import ContextMetadata
from .context_type import ContextType


class Context(UncheckedBaseModel):
    context_id: ContextId
    type: ContextType
    data: ContextData
    metadata: typing.Optional[ContextMetadata] = None
    is_event: ContextIsEvent
    updated_at: dt.datetime = pydantic.Field()
    """
    Time at which context was last updated.
    """

    created_at: dt.datetime = pydantic.Field()
    """
    Time at which context was created.
    """

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow", frozen=True)  # type: ignore # Pydantic v2
    else:

        class Config:
            frozen = True
            smart_union = True
            extra = pydantic.Extra.allow
